@echo off
goto start

                          
                            RES2SFX.BAT   
                           

                       Mon  08-15-1994  12:45:31

                 John De Palma on CompuServe 76076,571

     Ŀ
     COMMAND
     
                    RES2SFX  FileName (-no- *.EXE)


     Ŀ
     PURPOSE
     
     This batch program makes a Self Extracting File (SXF) with LHA.EXE.
     A (S)elf e(X)tracting (F)ile is one that requires no other file to
     extract its archived contents.

     Ŀ
     FILES NEEDED
     

          1.   File(s)        <-- Response File
          2.   !              <-- Header or Telop File
          3.   LHA.EXE        <-- Archiving program, Version 2.13
          4.   List           <-- List of files

     Ŀ
     RESPONSE FILE
     
     A "Response File" is a file listing the names of all the files to
     be archived. It is created by using an ASCII text editor. With DOS
     5.0 (or newer Versions) use EDIT.COM to load QBASIC.EXE. QBASIC.EXE
     is =both= an ASCII text editor and a QuickBASIC programming
     interpreter.

     You can use  RES.BAT (in this file set) on an =existing= archived
     file to make a Response File. Try RES.BAT on this SFX.

     RES2SFX.BAT looks for a "Response File" named File(s). The file,
     File(s) can contain the Full PATH of the files to archive if you
     want to recreate the subdirectories when the files are extracted.

     The symbol (@) is a critical switch for the RES2SFX.BAT; do NOT
     name the response file with "@" as the first letter of the file.

     Ŀ
     File(s)
     
     The following is =an example= of the correct full PATH format when
     you type the file names in the file File(s):

     .\WINDOWS\*.INI
     .\COURSE\*.*
     .\DOS\??????.ME
     .\DIAL\DIAL.DOC
     .\WINDOWS\SYSTEM\DIAL.EXE

     The following explains this PATH and file format.

     PATH & FileName                 Wild Card usage
         
     .\WINDOWS\*.INI             <-- all files with *.INI extension
     .\COURSE\*.*                <-- all files in Directory \COURSE
     .\DOS\??????.ME             <-- 6 letter file names with *.ME extension
     .\DIAL\DIAL.DOC
     .\WINDOWS\SYSTEM\DIAL.EXE

                       
                       
                         "DIAL.EXE" is the file
              
                "\WINDOWS\SYSTEM\" is the Directory
     
     Ŀ
             
              "dot" tells LHA.EXE to find the files in the sub
               directories where they exist, BUT to =restore= them
               starting at the directory you are in, =not= at the ROOT
               Directory!!! Makes the appropriate Directories in doing
               so! This trick is not to be found any where but here.
               This is a marvelous way to put files with the same names
               but different functions in separate directories. Works
               great for multiple programs of Visual BASIC for Windows
               which have the same file names for several programs.


     Or... if you don't want to create a Directory structure, type the
     file names to the -file- File(s) as:

     !                        <-- Always include this file
     DIAL.DOC
     DDADD.DOC
     DDADD.COM
     DDADD.C
     MACDEF.H
     LIST                     <-- Always include this file

     All the above files have to be in the same directory as RES2SFX.BAT

     Or... if you want to archive all the files in one directory, you
     =must= specify the directory name as:

     !
     G:\COURSE\*.*
     LIST

     Or... if you want to archive a diskette, just type:

     !
     *.*
     LIST

     into the file File(s). That command will archive =all= the files on
     the drive where RES2SFX.BAT resides.


     
       WARNING!  
     
     If you run the above command from C: Drive, it will try to archive
     =everything=, take "forever" and then probably fail as you will run
     out space to store this humongous archived file.



     Ŀ
     Header or "Telop" File
     
     A SXF made with LHA.EXE will display =first= any file with a name
     that begins with the exclamation character (!). A "[Y/N] Prompt" is
     displayed at the bottom of the screen. The program =waits= for the
     user to press "Y" to go on or "N" to abort. The file beginning with
     the exclamation character (!) =must= be listed first in the
     Response File when you archive the file set or this won't work.

     You can use the batch file in this file set called SORTRES.BAT to
     do that as the exclamation character (!) will be placed to the top
     of the file list (clever eh!) if you do so.

     The file in this file set named "!" is my Header file. You can edit
     it to your liking. This file should be one screen in width and
     length; do not to make it more than 24 rows long or 80 characters
     wide.

     Ŀ
     How to Make a Header File
     
     I use the ShareWare program "Screen Debut" by Willie Robinson. I
     registered it but couldn't find it on CompuServe when others asked
     where it was.... I then uploaded the ShareWare version to the
     CompuServe MSBASIC Forum as DEBUT1.ZIP. It is a great though
     unheralded text graphic program.

     Ŀ
     List File
     
     A list file is a file that lists all the files in the archive and
     is stored inside the archive. It is NOT a Response File as it
     contains archiving information, dates, and file sizes.

     The next is an example of a list file.


Listing of archive : TEST1.LZH

  Name          Original    Packed  Ratio   Date     Time   Attr Type  CRC
--------------  --------  -------- ------ -------- -------- ---- ----- ----
  !                 1796       371  20.7% 94-08-14 22:09:18 a--w -lh5- 1B24
+ COURSE.EXE       46093     45966  99.7% 94-08-08 22:20:24 a--w -lh5- B328
+ DDADD.EXE        16357     16341  99.9% 94-08-08 22:21:48 a--w -lh5- 6EC8
+ DIAL.EXE         21539     21522  99.9% 94-08-08 22:19:38 a--w -lh5- 237C
+ DOSTIM.ASP       47037     10067  21.4% 93-01-19 01:11:54 a--w -lh5- E340
+ FIXMDM.EXE       17774     17755  99.9% 94-08-08 22:19:08 a--w -lh5- 5AC8
  LIST              1389       570  41.0% 94-08-14 21:48:48 a--w -lh5- 92BD
--------------  --------  -------- ------ -------- --------
     7 files      151985    112592  74.1% 94-08-15 12:07:38


Ŀ
       
        The plus sign (+) means the file is stored with the full path


     Ŀ
     LHA.EXE Version 2.13
     
     Programmed by Haruyasu Yoshizaki (call him Yoshi) and released July
     20, 1991, LHA.EXE is a wonder of Public Domain archiving. Many
     commercial software companies use LHA.EXE to distribute their
     programs because it is an excellent and free archiver.

     Ŀ
     Where to put LHA.EXE
     
     Put LHA.EXE in a directory in your PATH. I put LHA.EXE in the same
     directory as my DOS files.

     Ŀ
     Demonstrate RES2SFX.BAT
     
     A copy of the file File(s) has been included in this file set
     primarily so you can test that this program works quickly and
     competently.

     Look at that file now to verify that =all= the files contained in
     its list have been extracted. Now... are you =sure= all those files
     have been extracted?!!???

     If NOT sure, read MELT.BAT, then run MELT.BAT and come back here.

     Then TYPE:

     RES2SFX  Test1   { Enter}

     to demonstrate how RES2SFX.BAT works.


                
                  Explanation of RES2SFX.BAT Commands  
                


     Ŀ
     BATCH FILE COMMANDS
     

     1st Command:        Tests to see if you entered a file to archive.
                         If you didn't, beeps and displays a short
                         message.

     2nd Command:        Makes a *.LZH file with full PATHs.

     3rd Command:        Makes a file named "LIST" which lists all the
                         files in the *.LZH archive.

     4th Command:        Adds the updated "LIST" file to the *.LZH file.

     5th Command:        Convert the *.LZH file to a "large model"
                         (S)elf e(X)tracting (F)ile. A "large model"
                         SXF:

                           a.  Restores subdirectory structures.

                           b.  Displays a Header (Telop) File first and
                               "[Y/N] Prompt."

                           c.  Can automatically start execution of a
                               batch file =inside= the archive called
                               !.BAT.

                               This batch file is called the "auto batch
                               Telop file" and is not to be confused
                               with the Header file which is also called
                               a "Telop" file. The Header file is
                               displayed when you execute the SFX file.

                               To start a batch file when you execute
                               the SFX file, the user must be instructed
                               to enter the command:

                                             FileName /!

                               to do this. This makes a snappy install
                               program. You can make a batch file called
                               INSTALL.BAT with the above command in it
                               and the install batch file inside the
                               archive (named !.BAT) will run.... Wild!!
                               PKZIP has nothing like this.

     6th Command:              Deletes the *.LZH file leaving only the
                               SFX file set behind.

     7th Command:              Ends the program.

:start
if "%1"=="" goto NoFile
call lha a /r2x1 %1 @File(s)
lha %1.LZH > list
lha u %1.LZH list
lha s /x1 %1
del %1.LZH
goto End
:NoFile
cls
echo 
echo.
echo                
echo                  COMMAND:     RES2SFX   FileName      
echo                
echo.
pause
:End
